<% . /usr/local/lib/cgi/generic.sh ; print_http_hdr %>
<% . /usr/local/lib/cgi/status.sh %>
<% . /usr/local/lib/cgi/config.sh %>
<% . ../sh/get_uci_data.sh %>

<html>
<head>
<link href="/sys/css/settings.css" rel="stylesheet" type="text/css">
<link href="/css/editbox.css" rel="stylesheet" type="text/css">
<style type="text/css">
.break {
 /* These are technically the same, but use both */
  overflow-wrap: break-word;
  word-wrap: break-word;

  -ms-word-break: break-all;
  /* This is the dangerous one in WebKit, as it breaks things wherever */
  word-break: break-all;
  /* Instead use this non-standard one: */
  word-break: break-word;

  /* Adds a hyphen where the word breaks, if supported (No Blink) */
  -ms-hyphens: auto;
  -moz-hyphens: auto;
  -webkit-hyphens: auto;
  hyphens: auto;

}
</style>
<noscript>
    <style type="text/css">
        .pagecontainer {display:none;}
    </style>
    <div class="noscriptmsg">
        You don't have JavaScript enabled. This page won't work!
    </div>
</noscript>
<script type="text/javascript" src="/sys/js/util.js"></script>
<script type="text/javascript" src="/js/util-ex.js"></script>
<script type="text/javascript" src="/js/uibasic.js"></script>
<script type="text/javascript" src="/js/draggable.js"></script>
<script type="text/javascript">
// channels table header
//var channelsHeader = ["","Channel Name","IP","Subscription Port","Audio Over Music","Audio Over Call","Channel Ads","Ads When No Audio","Frame Buffer Size","Channel Logo URL","Local Input","Local Streaming Port"];
//var channelsHeader = ["","Channel Name","IP","Subscription Port","Channel Logo URL","Local Input","Local Streaming Port"];
//var channelsHeader = ["","Channel Name","IP","Subscription Port","Channel Logo URL","Local Input","Streaming Port", "Streamer Output IP"];
var channelsHeader = ["","Channel Name","IP","Subscription Port","Channel Logo URL","Local Input","Streaming Port", "Streamer Output IP", "Frame Buffer Size"];

var uci_input = '<% get_ch_list %>';
var uci_params=uci_input.split(";");
var initialFormValues=new Array();

//new channel default values
var defaultIP='224.9.9.99';
var defaultPort=4444;              
var defaultPriorityOverMusic=1;     // Yes
var defaultPriorityOverCall=0;      // No
var defaultDisplayAds=1;            // Yes
var defaultDisplayAdsWhenNoAudio=1; // Yes  
var defaultFrameBufferSize=10;      // 10 frames
var defaultCharEncoding=0;          // ASCII
var defaultName = 'New_Channel';      // empty
var defaultLogoURL='http://';
var defaultInput = 'none';
var defaultStreamPort = 8050;
var defaultEncoderOutputIP = "";

var editModeEnum = { ADD:"add", EDIT:"edit"};
var editChan=1;
var editMode;

function initValues(){
    createUciEntries();
    for (i=0; i < uci_params.length;i++,i<50){
        set_val('application.channels.chan_'+ (i+1),uci_params[i]);
    }
    // Count initial form elements
    initialFormValues=getInitialFormValues('settings');
}

function createUciEntries(){
    var maxChans=get_val('application.general.max_channels');
    var tmpInputElement, tmpInputElementName;
    var postForm=document.forms['settings'];
    for (i=1;i <= maxChans;i++){
        tmpInputElementName = 'application.channels.chan_'+i;
        tmpInputElement = document.createElement("input");
        tmpInputElement.setAttribute('type','hidden');
        tmpInputElement.setAttribute('value','');
        tmpInputElement.setAttribute('id',tmpInputElementName);
        tmpInputElement.setAttribute('name',tmpInputElementName);
        tmpInputElement.setAttribute('style','vertical-align:middle');
        //finally, add the newly created object to DOM so that we can find/refer it
        //document.body.appendChild(tmpInputElement);
        postForm.appendChild(tmpInputElement);
    }
}

function getSelectedChan(){
    var radioElem = document.getElementsByName('chan_sel');
    for(var i = 0; i < radioElem.length; i++){
        if(radioElem[i].checked){
            return i+1;
        }
    }
    // no channels available: return 0
    return 0;
}

function submitCSV(){
    var csvFile=get_val('filename');
    if (csvFile.length == 0){
        alert('Please select first a file to upload');
    }else{
        // disable before unload handler
        window.onbeforeunload = null;
        document.forms['ucf'].submit();
    }
}

function validateMcastIp(ip) {
    return !!ip.match(/^(2(?:2[4-9]|3[0-9]))\.([0-2]?[0-9]?[0-9])\.([0-2]?[0-9]?[0-9])\.([0-2]?[0-9]?[0-9])$/g);
}

function checkMcastIp(ipElem){
    if (! validateMcastIp(ipElem.value)){
        alert('This is not a valid multicast address. Please choose an IP address between 224.0.0.0 and 239.255.255.255 !');
        ipElem.value=ipElem.defaultValue;
    }
}

function getInitialFormValues(theFormName){
    var tmpArrayElem = getAllFormElements(theFormName);
    var tmpValues=new Array();
    var i;
    for (i = 0; i < tmpArrayElem.length; i++) {
        tmpValues.push(tmpArrayElem[i].value);
    }
    return tmpValues;
}
    
function getAllFormElements(theFormName) {
    var allFormElements=new Array();
    var theFormElement = document.forms[theFormName];
    var i;

    // Get here all form elements.
    var formInputs = theFormElement.getElementsByTagName('input');
    var formSelects = theFormElement.getElementsByTagName('select');

    // Convert these Node lists to an Array.
    for (i = 0; i < formInputs.length; i++) {
        // ignore the radio buttons added by
        // redrawChannelsTable to select the channel to edit
        if (formInputs[i].name != 'chan_sel'){
            allFormElements.push(formInputs[i]);
        }
    }
    for (i = 0; i < formSelects.length; i++) {
        allFormElements.push(formSelects[i]);
    }
    return allFormElements;
}

function evalFormChanged(theFormName) {
    var hasChanged = false;
    var formElements = getAllFormElements(theFormName);
    if (formElements.length != initialFormValues.length){
        //we have added new elements to the form, do not look anymore
        hasChanged = true;
    }else{
        for (var i = 0; i < formElements.length; i++) {
            if (formElements[i].value != initialFormValues[i]) {
                hasChanged = true;
                break;
            }
        }
    }
    return hasChanged;
}

function checkFormOnLeave(theFormName){
    cancel_changes();
    if (evalFormChanged(theFormName) != false){
        // hitting a return will cause the browser to print its internal 
        // "navigate away" message.
        return '';
    }
    // reaching the end of the function w/o return will not print the message
}

function checkChanName(nameElem){
    var chanName=nameElem.value;
    var temp = chanName.replace(/("|'|;|,|\\|\s)/g,"");
    
    if (chanName.length != temp.length){
        alert('The use of single (\') and double (") quotes, colon (;), space ( ), backslash (\\) and comma (,) is not allowed in the Channel Name!');
        nameElem.value=nameElem.defaultValue;
    }
}

function checkChanURL(urlElem) {
    var urlName=urlElem.value;
    var temp = urlName.replace(/("|\\|\s)/g,"");

    if (urlName.length != temp.length){
        alert('The use of space ( ) and backslash (\\) is not allowed in the Channel URL!');
        urlElem.value=urlElem.defaultValue;
    }
}

function get_chl_state(buttonId, headTableId) {
    var mode = '<% get_mode %>';
        if (mode == 'master') {
            get_elem(buttonId).checked = true;
            get_elem(headTableId).style.display = 'table';
        } else {
            get_elem(buttonId).checked = false;
            get_elem(headTableId).style.display = 'table';
        }
}

function set_chl_state(buttonId, headTableId) {
        if (get_elem(buttonId).checked == true) {
            set_mode_UCI('master');
            get_elem(headTableId).style.display = 'table';
        } else {
            set_mode_UCI('slave');
            get_elem(headTableId).style.display = 'table';
        }
}

function onInputChange() {
    if (get_elem('edit_in').value == "none") {
        get_elem('edit_ip').disabled = false;
    } else {
        get_elem('edit_ip').disabled = true;
    }
}

function onEncoderOutputChange() {
    var curVal = get_elem('encoder_output_selector').value;
    if (curVal == "internal") {
        get_elem('edit_encoder_output_ip').style.visibility="hidden";
    } else {
        get_elem('edit_encoder_output_ip').style.visibility = "visible";
    }
}

    function isValidURL(urlElem) {
        var urlName=urlElem.value;
        var res = urlName.match(/(http(s)?:\/\/.)?(www\.)?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*)/g);

        if (res == null){
            urlElem.value=urlElem.defaultValue;
            alert('Invalid URL specified!');
            return false;
        }
        else {
            return true;
        }
    }

    function loadInitialIcon(){
        var loc = document.getElementById("edit_clu");
        createImgTag(loc.value);
    }

    function createImgTag(url){
        // Get icon location
        var loc = document.getElementById("iconLocation");
        // Delete icon  
        loc.innerHTML = "";
        // Create new icon element
        var newImg = document.createElement("IMG");
        newImg.src =  url + "?random=" + 
            new Date().getTime();
        newImg.width="55";
        //newImg.height="25";
        // Add icon to html
        loc.appendChild(newImg);
    }

    function waitAndRefreshImg(){
        function refreshImg(){      
            var iconName = document.getElementById("upload_icon_input");
            iconName = iconName.name;

            var iconUrl = "http://" + 
                window.location.host + 
                "/images/" + iconName;

            createImgTag(iconUrl );

            // Update "Channel Logo Url"
            var loc = document.getElementById("edit_clu");
            loc.value=iconUrl ;
        }
        // Delay the loading of the new image
        // so that is is more likely that
        // the upload has finished
        setTimeout(refreshImg, 700);
    }

    function setIconFileName(){
        var inputEl = document.getElementById("upload_icon_input");
        var fileName = inputEl.value;
        // Remove spaces in the name
        fileName = fileName.replace(/\s/g, '');
        // Remove path, keep file name only 
        fileName =  fileName.split('\\').pop().split('/').pop();
        // Save the extension
        var ext = fileName.substr(fileName.lastIndexOf('.') + 1);
        // Get only the 7 first chars
        fileName = fileName.substring(0,7);
        // Remove dots from the fileName because they are confusing
        fileName = fileName.replace(/\./g, '');
        // Add a prefix so that I can identify and delete all icons
        fileName = "icon" + fileName + "." + ext;
        // Set icon file name in a DOM element to be used as
        // POST argument that will be read by the CGI script
        inputEl.name = fileName;
    }

    function delete_stored_icons() {
        // if PC
        //var URL = './cgi-bin/delete-stored-icons.cgi';
        // else if board
        var URL = './delete-stored-icons.cgi';
        var xmlHttp = new XMLHttpRequest();

        //https://www.w3schools.com/xml/ajax_xmlhttprequest_response.asp
        // readyState: connection state. 4 is rquest finished and
        //  response is ready
        // status: status-text. 200: "OK"

        xmlHttp.onreadystatechange = function() {
            if (this.readyState == 4 ) {
                if (this.status == 200) {
                    // No need to report the status
                    //alert("Succeeded to delete icons.");
                } else {
                    // No need to report the status
                    //alert("Failed to delete icons: " + this.statusText);
                }
            }
        }

        xmlHttp.open("GET", URL, true);
        xmlHttp.send(null);
    }

</script>

</head>
<title>Barix Audiopoint - Channel Settings</title>
<!--<body onload="initValues();initPage();">-->

<body onbeforeunload="return checkFormOnLeave('settings')" onload="get_chl_state('ch_list_btn','t1');initValues();initPage();initDragElem('editbox');">
<form name="settings" action=config.cgi method=POST>
    <input type=hidden name=return_page value=cgi-bin/uibasic.cgi>

<!--Load controller params -->
<!-- Hardcoded number of max channels -->
    <input  type=hidden 
            name="application.general.channel_count" 
            id="application.general.channel_count" 
            value="<% get_ch_num %>">
    <input  type=hidden 
            name="application.general.max_channels" 
            id="application.general.max_channels"
            value="50">

<!-- Load channel params are automatically generated as page load-->
 
<div class=pagecontainer>           


<table id="head_table" cellspacing=5 width="600px">
    <tr>
        <td colspan="2">CHANNEL SETTINGS<br><br>
    </tr>
    <tr>
        <td>
            <input type="checkbox" id="ch_list_btn" onclick="set_chl_state('ch_list_btn','t1');">Channel list server<br>
        </td>
    </tr>
</table>

<table id="t1" cellspacing=5>
    <tr>
        <td>
		  <!--
            <table id="channel_table" cellpadding=5 
				style="table-layout: fixed;border: 1px solid black;width: 1000px; vertical-align:middle">
		  -->
            <table id="channel_table" cellpadding=5 
				style="border: 1px solid black;width: 100%; vvertical-align:middle">
				<!--
                <colgroup>
                    <col span="1" style="width: 15px;">
                    <col span="1" style="width: 60px;">
                    <col span="1" style="width: 50px;">
                    <col span="1" style="width: 65px;">
                    <col span="1" style="width: 100px;">
                    <col span="1" style="width: 40px;">
                    <col span="1" style="width: 70px;">
                </colgroup>
				-->
				
            </table>
        <td>
    </tr>
</form>
    <tr>
        <br>
        <td>
            <input type=button style="width: 160px;" text-align="center" id="add_channel" value="Add New Channel" title="Inserts a new channel with the default settings before the selected one" style="width:120px" onclick=addNewChannel(getSelectedChan());> 
            <input type=button style="width: 160px;" text-align="center" id="edit_channel" value="Edit Channel" title="Opens edit box for the selected channel">
            <input type=button style="width: 160px;" text-align="center" id="del_channel" value="Delete Channel" title="Deletes the selected channel" onclick=deleteChannel(getSelectedChan());>
            <input type=button style="width: 160px;" text-align="center" id="del_all" value="Delete All Channels" title="Deletes all channels" onclick=deleteAllChannels();> 
        </td>
    </tr> 
</table>

<table id="set_changes">
    <tr><td class="wh"><hr size="1" noshade></tr>
    <tr>
        <td class="normal" colspan=10>
            <!--
                Remove double call to apply_changes->set_uci.cgi->apply
                <input type="button" style="width: 160px;"  text-align="center" 
                    value="Apply Changes" style="width:120px"
                    onclick="window.onbeforeunload = null;apply_changes();
                    document.forms['settings'].submit();">
            --> 

			<input type="button" style="width: 160px;"  text-align="center" 
				value="Apply Changes" style="width:120px"
				onclick="window.onbeforeunload = null;
				validateAndSendForm();">


            <!-- The form elements are dynamic, better simulate form cancel 
            by page reload -->
            <input type="button" style="width: 160px;"  text-align="center" 
                value="Cancel Changes" onclick="window.onbeforeunload = null; 
                document.forms['settings'].reset(); location.reload();
                cancel_changes();">

            <input type="button" style="width: 160px;"  text-align="center" 
                value="Delete Stored Icons" onclick="delete_stored_icons();">

        </td>
    </tr>
</table>

<!-- the advanced params edit "pop up" -->

<div id="editbox" draggable="true">
     <div>
        <table id="edit_table" cellpadding=6 width="400px">
            <thead>
                <tr>
                    <th width="25%"></th>
                    <th width="75%"></th>
                </tr>
            </thead>
            <tr>
                <td colspan="2" style="text-align:center;">CHANNEL SETTINGS</td>
                <td></td>
            </tr>
            <tr>
                <td>Channel Name</td>
                <td><input id="edit_cn" size="16" maxlength="30" value=""
                    ondblclick="this.select();"
                    onchange=checkChanName(this);></td>
            </tr>
            <tr>
                <td>IP Address and Port</td>
                <td>
                    <input id="edit_ip" size="15" maxlength="15" value="" 
                        ondblclick="this.select();"
                        onchange=IPAddrCheck(this,1);>
                    <input id="edit_port" size="5" maxlength="5" value="" 
                        ondblclick="this.select();"
                        onchange=PortCheck(this,1024);>
                </td>
            </tr>
            <tr>
                <td>Local Input</td>
                <td><select id="edit_in" onchange="onInputChange()">
                        <option id="option_in_l" value="left">Left</option>
                        <option id="option_in_r" value="right">Right</option>
                        <option id="option_in_n" value="none">None</option>
                </td>
            </tr>

            <tr>
                <td>Streamer Output IP Address</td>
                <td><select id="encoder_output_selector" onchange="onEncoderOutputChange()">
                        <option id="option_enc_internal_out" value="internal">Internal</option>
                        <option id="option_enc_external_out" value="external">External</option>

                </td>
            </tr>
            <tr>
                <td>Streamer Output IP Address</td>
                <td>
                    <input id="edit_encoder_output_ip" size="15" maxlength="15" value="" 
                        ondblclick="this.select();"
                        onchange=IPAddrCheck(this,1);>
                </td>
            </tr>
            <tr>
                <td>Streaming Port</td>
                <td>
                    <input id="edit_strport" size="5" maxlength="5" value=""
                        ondblclick="this.select();"
                        onchange=PortCheck(this,1024);>
                </td>
            </tr>
            <tr>
                <td>Frame Buffer Size</td>
                <td><input id="edit_fbs" size="3" maxlength="3"></td>
            </tr>
            <tr>
                <td>Channel Logo URL</td>
                <td><input id="edit_clu" size="16" maxlength="130" value=""
                        ondblclick="this.select();"
                        onchange=isValidURL(this);></td>
            </tr>


            <tr>
                <td>Browse Logo File</td>
                <td>
                    <form  action="upload-icon.cgi" 
                        method="post" enctype="multipart/form-data">
                        <input id="upload_icon_input" type="file" onchange=
                            "
                            window.onbeforeunload = null;   
                            setIconFileName();
                            this.form.submit();
                            waitAndRefreshImg();"
                            "
                            name="pending"/>
                    </form>
                </td>
            </tr>
            <tr>
                <td>Logo</td>
                <td id="iconLocation">
                    <img id="iconOne" src="/images/icon-one" width="25" 
                        height="25">
                </td>
            </tr>

            <tr><td class="wh"><hr size="1" noshade></td></tr>
            <tr>
                 <td colspan="2">
                     <input type=button value="Update Channel" 
                      title="Updates the channel table with the changes for this channel"
                      onclick="closeEditBox(editChan, editMode);"/>
                    <input type=button value="Cancel" 
                     title="Closes the edit box ignoring all the changes"
                     onclick="cancelEditBox(editChan, editMode);"/>
                 </td>
            </tr>
         </table>
     </div>
</div>
</div> <!-- End of page container -->

</body>
</html>
